import { curry2 } from './curry2';
export function curry3(fn) {
    function curried(a, b, c) {
        switch (arguments.length) {
            case 1:
                return curry2(function (b, c) { return fn(a, b, c); });
            case 2:
                return function (c) { return fn(a, b, c); };
            default:
                return fn(a, b, c);
        }
    }
    return curried;
}
//# sourceMappingURL=curry3.js.map